VERSION 5.00
Object = "{248DD890-BB45-11CF-9ABC-0080C7E7B78D}#1.0#0"; "MSWINSCK.OCX"
Begin VB.Form Form1 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "AirexMsg"
   ClientHeight    =   4410
   ClientLeft      =   150
   ClientTop       =   435
   ClientWidth     =   8040
   Icon            =   "AirexMsg.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   4410
   ScaleWidth      =   8040
   StartUpPosition =   2  'CenterScreen
   Begin VB.Timer Timer1 
      Interval        =   1000
      Left            =   1320
      Top             =   2640
   End
   Begin MSWinsockLib.Winsock Sck 
      Left            =   1920
      Top             =   2640
      _ExtentX        =   741
      _ExtentY        =   741
      _Version        =   393216
      Protocol        =   1
      RemotePort      =   1980
      LocalPort       =   1980
   End
   Begin VB.TextBox OutputTXT 
      Height          =   2415
      Left            =   0
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      TabIndex        =   1
      Top             =   240
      Width           =   8055
   End
   Begin VB.TextBox InputTXT 
      Height          =   1455
      Left            =   0
      MultiLine       =   -1  'True
      TabIndex        =   0
      Top             =   3000
      Width           =   8055
   End
   Begin VB.Label Label3 
      Caption         =   "To send message press Shift+Enter"
      Height          =   255
      Left            =   5400
      TabIndex        =   4
      Top             =   2760
      Width           =   2655
   End
   Begin VB.Label Label2 
      Caption         =   "Text to Send:"
      Height          =   255
      Left            =   0
      TabIndex        =   3
      Top             =   2760
      Width           =   1095
   End
   Begin VB.Label Label1 
      Caption         =   "Conversation with "
      Height          =   255
      Left            =   120
      TabIndex        =   2
      Top             =   0
      Width           =   7935
   End
   Begin VB.Menu ActionBTN 
      Caption         =   "&Action"
      Begin VB.Menu BindBTN 
         Caption         =   "&Make On-line"
      End
      Begin VB.Menu MakeOffLineBTN 
         Caption         =   "Ma&ke Off-line"
      End
      Begin VB.Menu ConnBTN 
         Caption         =   "&Connect"
      End
      Begin VB.Menu DiscBTN 
         Caption         =   "&Disconnect"
      End
      Begin VB.Menu QuitBTN 
         Caption         =   "&Quit"
      End
   End
   Begin VB.Menu OptionBTN 
      Caption         =   "&Option"
   End
   Begin VB.Menu HelpBTN 
      Caption         =   "&Help"
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Const CONN = 1
Const DISCONN = 2
Const NIL = 0
Const MAX_TIME_OUT = 5 'max secs to wait before launch TimeOut

Public connected As Boolean
Public connecting As Boolean
Public disconnecting As Boolean
Public localHost As String
Public remoteHost As String
Public recPort As String
Public sendPort As String
Public timer_action As Long
Public timer_timeout As Long
Public online As Boolean

Private Sub BindBTN_Click()
 If Not connected And online Then
  Sck.Close
  online = False
 End If
 If Not connected And Not online Then
  Sck.Bind recPort
  MsgBox "Binding on port " & recPort & "..."
  online = True
  Exit Sub
 End If
 If connected Then
  MsgBox "You are connected, disconnect first ..."
 End If
End Sub

Private Sub ConnBTN_Click()
 Connect
End Sub

Private Sub DiscBTN_Click()
 Disconnect
End Sub

Private Sub Form_Load()
 Init
End Sub

Private Sub Form_Unload(Cancel As Integer)
 If connected Then Disconnect
End Sub

Private Sub InputTXT_KeyUp(KeyCode As Integer, Shift As Integer)
  If Not connected Then Exit Sub
  If KeyCode = 13 Then SendTXT
End Sub


' Functions
Public Sub Init()
 online = False
 connected = False
 recPort = 1980
 sendPort = 1980
 connecting = False
 disconnecting = False
 localHost = "localhost"
 remoteHost = "localhost"
 Sck.RemotePort = sendPort
 Timer1.Enabled = False
 timer_action = NIL
 timer_timeout = 0 'number of secs gone from timer start
End Sub

Private Sub SendTXT()
If Not connected Then
 MsgBox "Not Connected", vbCritical, "ATTENTION"
 Exit Sub
End If
If Trim(InputTXT.Text) = "" Then Exit Sub
Sck.SendData localHost & "+" & InputTXT.Text
OutputTXT.Text = OutputTXT.Text & Chr(13) & remoteHost & ": " & InputTXT.Text
InputTXT.Text = ""
End Sub

' S = Host A
' R = Host B
' S is connected to R if :
' - S send "CONN+<localhostS>" to R -> R set remoteHost = localhostS
' - R replies "ACK+<localhostR>" to S -> S now knew R is listening
Private Sub Connect()
 If connected Then
  MsgBox "Already connected"
  Exit Sub
 End If
 If Not online Then
  MsgBox "You are not on-line!"
  Exit Sub
 End If
 Sck.remoteHost = remoteHost
 Sck.RemotePort = sendPort
 localHost = localHost
 Sck.SendData "CONN+" & localHost
 connecting = True
 timer_action = CONN
 Timer1.Enabled = True
 timer_timeout = 0
End Sub

' S = Host A
' R = Host B
' S is disconnected to R if :
' - S send "DISCONN+<localhostS>" to R
' - R replies "ACK+<localhostR>" to S
Private Sub Disconnect()
 If Not connected Then
  MsgBox "Already disconnected"
  Exit Sub
 End If
 Sck.SendData "DISCONN+" & localHost
 disconnecting = True
 timer_action = DISCONN
 Timer1.Enabled = True
 timer_timeout = 0
End Sub

Private Sub Check()
 Sck.SendData "DISCONN+" & localHost
 disconnecting = True
End Sub

Private Sub MakeOffLineBTN_Click()
 If online = False Then
  MsgBox "You are already off-line"
  Exit Sub
 End If
 If connected Then
  MsgBox "Before go off-line you have to disconnect"
  Exit Sub
 End If
 If online Then
  Sck.Close
  online = False
  MsgBox "You are Off-line now!"
 End If
End Sub

Private Sub OptionBTN_Click()
 OptionFRM.Show
 Me.Enabled = False
End Sub

Private Sub QuitBTN_Click()
 If connected Then Disconnect
 Unload Me
End Sub

' Msg = <RemoteIP>+Text
Private Sub Sck_DataArrival(ByVal bytesTotal As Long)
 Dim tmp As String
 Sck.GetData tmp
 If connecting Then 'If arrives ACK we are connected
  If tmp = ("ACK+" & remoteHost) Then
    connecting = False
    connected = True
    OutputTXT.Text = ""
    InputTXT.Text = ""
    Label1.Caption = "Conversation with " & remoteHost
    Timer1.Enabled = False
    timer_timeout = 0
    timer_action = NIL
  End If
  Exit Sub
 End If
 If disconnecting Then ' If arrives ACK we are disconnected
  If tmp = ("ACK+" & remoteHost) Then
   connected = False
   disconnecting = False
   Label1.Caption = "Conversation with: "
    Timer1.Enabled = False
    timer_timeout = 0
    timer_action = NIL
  End If
  Exit Sub
 End If
 If connected Then ' check data arrived if we are connected
  If Left(tmp, 8) = "DISCONN+" Then
    tmp = Replace(tmp, "DISCONN+", "")
    If tmp = remoteHost Then
     Sck.SendData "ACK+" & localHost
     connected = False
     Label1.Caption = "Conversation with "
    Else: MsgBox "Incorrect Disconnect Msg!", vbCritical, "ATTENTION"
    End If
   Exit Sub
  End If
  If InStr(remoteHost, tmp) = 0 Then 'msg arrived!
  tmp = Replace(tmp, remoteHost & "+", "")
  OutputTXT.Text = OutputTXT.Text & Chr(13) & remoteHost & ": " & tmp
  Else: MsgBox "Incorrect Data!", vbCritical, "ATTENTION"
  End If
  Exit Sub
 End If
 'if we are not connected ...
 If Left(tmp, 5) = "CONN+" Then
  tmp = Replace(tmp, "CONN+", "")
  If tmp = remoteHost Then
   Sck.remoteHost = remoteHost
   Sck.RemotePort = sendPort
   Sck.SendData "ACK+" & localHost
   connected = True
   OutputTXT.Text = ""
   InputTXT.Text = ""
   Label1.Caption = "Conversation with " & remoteHost
  Else: MsgBox "Incorrect Conn Msg!", vbCritical, "ATTENTION"
  End If
 Else: MsgBox "Incorrect CONN Msg!", vbCritical, "ATTENTION"
 End If
End Sub

Private Sub Sck_Error(ByVal Number As Integer, Description As String, ByVal Scode As Long, ByVal Source As String, ByVal HelpFile As String, ByVal HelpContext As Long, CancelDisplay As Boolean)
 MsgBox Description
End Sub

Private Sub Timer1_Timer()
 timer_timeout = timer_timeout + 1
 If timer_timeout = MAX_TIME_OUT Then
   If timer_action = CONN Then
    connecting = False
    connected = False
    MsgBox "TIMEOUT : Unable to connect to " & remoteHost & ", Port " & sendPort
   End If
   If timer_action = DISCONN Then
    disconnecting = False
    connected = False
    MsgBox "TIMEOUT : Disconnection forced from " & remoteHost & ", Port " & sendPort
   End If
  Timer1.Enabled = False
  timer_timeout = 0
  timer_action = NIL
 End If
End Sub
